classdef AudioRecorder
    %AUDIORECORDER Summary of this class goes here
    %   Detailed explanation goes here
    properties (Access = public)       
    end
    methods(Static)
        function recorder = CreateRecorder(fs, bits, n, id)
            arguments
                fs (1,1) double {mustBeFinite} = 96e3;
                bits (1,1) double {mustBeFinite} = 16;
                n (1,1) double {mustBeFinite} = 1;
                id (1,1) double {mustBeFinite} = 0;
            end
            %AUDIORECORDER Construct an instance of this class
            %   Detailed explanation goes here           
            recorder = audiorecorder(fs, bits, n, id);
        end
        
        function Record(audiorecorder)
            %METHOD1 Summary of this method goes here
            %   Detailed explanation goes here
            audiorecorder.StartFcn = 'disp(''Empieza'')';
            audiorecorder.StopFcn = 'disp(''Terminada grabación'')';
            record(audiorecorder);
        end
        
        function audio = StopRecording(audiorecorder, idAudio, audioPath)
            arguments
                audiorecorder
                idAudio
                audioPath (1, :) char
            end
            %METHOD1 Summary of this method goes here
            %   Detailed explanation goes here
            stop(audiorecorder);
            y = getaudiodata(audiorecorder);

            finalPath = append(audioPath,'\', idAudio,'.wav');
            audiowrite(finalPath, y, audiorecorder.SampleRate);
            audio = y;
        end

        function PlotSpectral(audiopath)
            [xn, fs]=audioread(audiopath);
            %nf: number of point in DTFT
            nf=1024;
            Y = fft(xn,nf);
            f = fs/2*linspace(0,1,nf/2+1);
            plot(f,abs(Y(1:nf/2+1)));
        end
    end
end

